// ########################################################################
// ## anzahltabelle.h:                                                   ##
// ## Klasse zur Verwaltung der Anzahltabelle fr RandCubic              ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#ifndef ANZAHLTABELLE_H
#define ANZAHLTABELLE_H


#include "../system.h"


// Klasse zur Verwaltung der Anzahltabelle
class Anzahltabelle
{
   public:
   // Konstruktor und Destruktor
   Anzahltabelle();
   ~Anzahltabelle();

   // Abfrage der Anzahl der Eintrge und tabelleneintrge
   inline const card32 Eintraege();
   inline const card64 A(const long n);
   inline const card64 B(const long n);
   inline const card64 C(const long n);
   inline const card64 D(const long n);
   
   friend ostream& operator<<(ostream& os, const Anzahltabelle& tabelle);

   private:
   card32  eintraege;
   card64* speicher;
   card64* tabelleA;
   card64* tabelleB;
   card64* tabelleC;
   card64* tabelleD;
};

extern Anzahltabelle tabelle;

#endif
