// ########################################################################
// ## graphwidget.h                                                      ##
// ## Viewer fr Graphenlisten                                           ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#ifndef GRAPHWIDGET_H
#define GRAPHWIDGET_H

#include <qapp.h>
#include <qpainter.h>
#include <qlist.h>

#include "../system.h"
#include "../tdgf/graph.h"
#include "../tdgf/graph.icc"


class GraphWidget : public QWidget
{
   Q_OBJECT
   public:
   GraphWidget(QWidget* parent = NULL, const char* name = NULL);        
   ~GraphWidget();
 
   void Neu();
   void Reset();
   void FuegeAn(const Graph& g); 
   void Einstellungen(int32 x, int32 y);
   void ZeichneGraph(QPainter* painter,
                     const card32 x,
                     const card32 y,
                     const card32 breite,
                     const card32 hoehe,
                     Graph* t,
                     const card32 num) const;
   void ZeichneSeite(const card32 start,
                     QPainter* painter,
                     const card32 wx,
                     const card32 wy,
                     const card32 wbreite,
                     const card32 whoehe) const;
   void NaechsteSeite();
   void VorherigeSeite();
   void ErsteSeite();
   void LetzteSeite();

   inline int32 AnzahlX()  const;
   inline int32 AnzahlY()  const;
   inline int32 Position() const;
   inline int32 Seite()    const;
   inline int32 Seiten()   const;
   inline int32 Anzahl()   const;

   public slots:
   void paintEvent(QPaintEvent *);
   void scrollBarEvent(int);

   signals:
   void neueSeite();

   private:
   void          NeueSeite();  
   QList<Graph>* liste;
   QScrollBar*   scrollBar;
   int32         anzahlX;
   int32         anzahlY;
   int32         position;
   int32         seite;
   int32         seiten;
};

#endif
